// SetPointAppOverrideNuker.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "LeoHelpers.h"
#include "SetPointAppOverrideNuker.h"
#include "ModifySetPointConfig.h"

HINSTANCE g_hInstance = 0;

INT_PTR CALLBACK DlgProcMain(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

int APIENTRY wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow)
{
	g_hInstance = hInstance;

	InitCommonControls();

	HWND hwndMainDlg = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProcMain, NULL);

	if (hwndMainDlg == NULL)
	{
		MessageBox(NULL, L"CreateDialogParam failed", SPAON_MB_TITLE, MB_OK | MB_ICONERROR);
		return 0;
	}

	LeoHelpers::CenterWindow(hwndMainDlg, NULL);
	ShowWindow(hwndMainDlg, nCmdShow);
	UpdateWindow(hwndMainDlg);

	MSG msg = {0};

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!IsDialogMessage(hwndMainDlg, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return static_cast<int>( msg.wParam );
}

INT_PTR CALLBACK DlgProcMain(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	default:
		return FALSE; // Standard handling.

	case WM_INITDIALOG:
		SendMessage(hwndDlg, WM_SETICON, ICON_BIG,   reinterpret_cast< LPARAM >( LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_LARGE), IMAGE_ICON, 32, 32, 0) ) );
		SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, reinterpret_cast< LPARAM >( LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_SMALL), IMAGE_ICON, 16, 16, 0) ) );

		// Can't put the text in the dialog due to resource compiler's stupid 256 character limit.
		{
			HWND hwndStaticDescription = GetDlgItem(hwndDlg, IDC_STATIC_DESCRIPTION);
			if (hwndStaticDescription != NULL)
			{
				SetWindowText(hwndStaticDescription, L"This simple app modifies the Logitech SetPoint config files to permanently remove the application overrides for mouse buttons and wheel settings.\n\nYou can remove the overrides using the SetPoint GUI but they will come back after a reboot (possibly only if it detects certain applications, e.g. Office). A bug in SetPoint means it doesn't properly save the configuration change to disk. Inexplicably, this bug has been in SetPoint for over three years.");
			}
		}
		return TRUE; // Set focus to the control in wParam.

	case WM_DESTROY:
		PostQuitMessage(0);
		return FALSE; // Standard handling.

	case WM_COMMAND:
		int iWmId    = LOWORD(wParam);
		int iWmEvent = HIWORD(wParam);

		if (iWmEvent == BN_CLICKED)
		{
			if (iWmId == IDCANCEL)
			{
				DestroyWindow(hwndDlg);
				return TRUE; // We handled it.
			}

			if (iWmId == IDC_BUTTON_WEB)
			{
				SHELLEXECUTEINFO sei = {0};
				sei.cbSize = sizeof(sei);
				sei.lpFile = L"http://www.pretentiousname.com/setpoint_aon/";
				ShellExecuteEx(&sei);
				return TRUE; // We handled it.
			}

			if (iWmId == IDC_BUTTON_DOIT)
			{
				ModifySetPointConfig::Main(g_hInstance, hwndDlg, false);
				return TRUE; // We handled it.
			}

			if (iWmId == IDC_BUTTON_UNDO)
			{
				ModifySetPointConfig::Main(g_hInstance, hwndDlg, true);
				return TRUE; // We handled it.
			}
		}

		return FALSE; // Standard handling.
	}
}
